# Gamerules
gamerule doImmediateRespawn false
gamerule spectatorsGenerateChunks true

# Destroy disabled Soul Charms
execute if score mnc_settings mnc_revival matches 0 at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run summon item ~ ~ ~ {Item:{id:"minecraft:totem_of_undying"}}
execute if score mnc_settings mnc_revival matches 0 at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run summon item ~ ~ ~ {Item:{id:"minecraft:redstone_block",count:4}}
execute if score mnc_settings mnc_revival matches 0 at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run summon item ~ ~ ~ {Item:{id:"minecraft:bone_block",count:2}}
execute if score mnc_settings mnc_revival matches 0 at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run summon item ~ ~ ~ {Item:{id:"minecraft:copper_block",count:2}}
execute if score mnc_settings mnc_revival matches 0 run kill @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}]

# Revive
execute at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run tag @p[distance=..2,gamemode=spectator] add Revive
execute at @a[tag=Revive] run kill @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}}},limit=1,distance=..5]
execute at @a[tag=Revive] run gamemode survival @p
execute if score mnc_settings mnc_soulCharmDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:slowness 60 1 true
execute if score mnc_settings mnc_soulCharmDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:weakness 60 1 true
execute if score mnc_settings mnc_soulCharmDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:glowing 60 1 true
execute if score mnc_settings mnc_soulCharmDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:hunger 60 1 true
execute if score mnc_settings mnc_soulCharmDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:mining_fatigue 60 1 true
execute if score mnc_settings mnc_soulCharmDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:poison 2 0 true
execute if score mnc_settings mnc_defaultLives matches 1 at @a[tag=Revive] run scoreboard players set @p Lives 1
execute if score mnc_settings mnc_defaultLives matches 3 at @a[tag=Revive] run scoreboard players set @p Lives 2
execute if score mnc_settings mnc_defaultLives matches 5 at @a[tag=Revive] run scoreboard players set @p Lives 3
execute at @a[tag=Revive] run playsound minecraft:ui.toast.challenge_complete master @a ~ ~ ~ 10 1
execute at @a[tag=Revive] if dimension minecraft:overworld run spawnpoint @p
execute at @a[tag=Revive] if dimension minecraft:the_nether run spawnpoint @p

execute at @a[tag=Revive] run tag @p remove Revive

# Detect deaths
execute as @a[scores={deaths=1..}] run function minicore:death

# Check for Life Jam uses
execute as @a[scores={lifeReset=1..}] if score mnc_settings mnc_defaultLives matches 3 run function minicore:life_reset_3
execute as @a[scores={lifeReset=1..}] if score mnc_settings mnc_defaultLives matches 5 run function minicore:life_reset_5

# Ghost particles
execute at @a[gamemode=spectator,scores={Lives=..0}] run particle dust{color:[1.000,1.000,1.000],scale:1} ~ ~1.5 ~ 0.5 0.5 0.5 0 2 force

# Possess
execute at @a[gamemode=spectator,scores={Lives=..0}] run tag @a[distance=..1,gamemode=survival] add Possessed
effect give @a[tag=Possessed] minecraft:strength 1 0 true
effect give @a[tag=Possessed] minecraft:speed 1 0 true
effect give @a[tag=Possessed] minecraft:resistance 1 0 true
effect give @a[tag=Possessed] minecraft:glowing 1 0 true
tag @a remove Possessed

# Fix scores
execute if score mnc_settings mnc_defaultLives matches 1 run scoreboard players set @a[tag=!nHrCheck] Lives 1
execute if score mnc_settings mnc_defaultLives matches 3 run scoreboard players set @a[tag=!nHrCheck] Lives 3
execute if score mnc_settings mnc_defaultLives matches 5 run scoreboard players set @a[tag=!nHrCheck] Lives 5
scoreboard players set @a nothing 0

# Set team colors
execute if score mnc_settings mnc_nameColors matches 1 if score mnc_settings mnc_defaultLives matches 3 run function minicore:team_colors_3
execute if score mnc_settings mnc_nameColors matches 1 if score mnc_settings mnc_defaultLives matches 5 run function minicore:team_colors_5

# Set player teams
execute unless score mnc_settings mnc_defaultLives matches 1 run function minicore:join_teams

tag @a add nHrCheck

# Defaults
execute unless score mnc_settings mncDefaults matches 1 run scoreboard players set mnc_settings mnc_lifeJam 1
execute unless score mnc_settings mncDefaults matches 1 run scoreboard players set mnc_settings mnc_soulCharmDebuffs 1
execute unless score mnc_settings mncDefaults matches 1 run scoreboard players set mnc_settings mnc_nameColors 1
execute unless score mnc_settings mncDefaults matches 1 run scoreboard players set mnc_settings mnc_tablist 1
execute unless score mnc_settings mncDefaults matches 1 run scoreboard objectives setdisplay list Lives
execute unless score mnc_settings mncDefaults matches 1 run scoreboard players set mnc_settings mnc_defaultLives 3
execute unless score mnc_settings mncDefaults matches 1 run scoreboard players set mnc_settings mnc_revival 1
execute unless score mnc_settings mncDefaults matches 1 run scoreboard players set mnc_settings mnc_reviveLifeCount 2
scoreboard players set mnc_settings mncDefaults 1
